

import java.awt.*;
import java.rmi.*;
import java.applet.*;

public class
clientApplet extends Applet
{
  
   NetPlayer aPlayer ;
   SessionManagerInterface mngr;
   UI ui;
   SessionInfo ret[] ; 
   SessionInterface currentSession;
   int currentSessionId=-1;

   String message = "";


   public void 
   init()
   {

       try 
       {
          mngr = (SessionManagerInterface)Naming.lookup("//" + getCodeBase().getHost() + "/SessionManager");

          System.out.println("I got it!");
          System.out.println("Host  !"+getCodeBase().getHost());

          aPlayer = new NetPlayer("timucin");


          /*
          NetPlayer aPlayer = new NetPlayer("timucin");
          mngr.postInvitation(aPlayer);
          System.out.println("I posted the Invitation !");
          */

          ret = mngr.getListOfSessions();

          if(ret!=null)
          {
             System.out.println(" Threre are  "+ret.length+" sessions ! ");
             for(int i=0;i<ret.length;i++)
             {
               System.out.println(" Session : "+i);
               System.out.println("Number "+ret[i].getSessionId());
               System.out.println("State "+ret[i].getState());
             }
          }
          else System.out.println("No session available");
          

        } catch (Exception e) 
          {
               System.out.println("HelloApplet exception: " + e.getMessage());
                        e.printStackTrace();
          }
      ui = new UI(this); 
      ui.updateSessionList(ret);
      add(ui);
   }

   /**
   */
   public void
   postInvitation(String aName) throws java.rmi.RemoteException
   {

      mngr.postInvitation(aPlayer);
      System.out.println("I posted the Invitation !");

   }

   /**
   */
   public void
   joinSession(int sessId) throws java.rmi.RemoteException
   {
      String myId = mngr.joinSession(aPlayer,sessId);

      if(myId!=null)
      {
         currentSessionId = sessId;
         currentSession = mngr.getSessionWithId(sessId);
      }

      System.out.println("I joined the Sesion "+myId);
      
   }// end of joinSession()

   /**
   */
   public void
   refreshSessions() throws java.rmi.RemoteException
   {

       ret = mngr.getListOfSessions();

       if(ret!=null)
       {
          System.out.println(" Threre are  "+ret.length+" sessions ! ");
          for(int i=0;i<ret.length;i++)
          {
            System.out.println(" Session : "+i);
            System.out.println("Number "+ret[i].getSessionId());
            System.out.println("State "+ret[i].getState());
          }
       }
       else System.out.println("No session available");
       ui.updateSessionList(ret);
       if(currentSession!=null) currentSession.push(new Message(Message.JOIN));
          
      
   }

}
